-----------------------------------------------------------------------------------------------
-- Client Lua Script for PoopEsperInnate
-- Created by Caleb calebzor@gmail.com because Esper innate is poo poo /pei
-----------------------------------------------------------------------------------------------

-- Note: leaving bunch of the old code in in case reverting is needed
require "Window"
require "GameLib"

local GameLib = GameLib
local Apollo = Apollo
local setmetatable = setmetatable
local ipairs = ipairs
local Print = Print

local addon = Apollo.GetPackage("Gemini:Addon-1.1").tPackage:NewAddon("PoopEsperInnate", false, {}, "Gemini:Timer-1.0")
local GeminiConfig = Apollo.GetPackage("Gemini:Config-1.0").tPackage
--local GeminiGUI = Apollo.GetPackage("Gemini:GUI-1.0") and Apollo.GetPackage("Gemini:GUI-1.0").tPackage or {}

local uPlayer
--local nMaxBuffs = 255 -- XXX assume can't have more than 255 buffs
--local nSpellId = 58586
--nSpellId = 38544
--[[
This is how you can get the Id of the spell when you have it as a buff
for k, v in ipairs(GameLib.GetPlayerUnit():GetBuffs().arBeneficial) do
  if v.splEffect:GetName() == "Spectral Form" then
    Print(v.splEffect:GetId())
  end
end
]]--
local nAnchorEdge = 3
--local nBuffIndex = 0

--function addon:new(o)
--	o = o or {}
--	setmetatable(o, self)
--	self.__index = self
--	--self.wBuffs = nil
--
--	return o
--end
--
--function addon:Init()
--	--Apollo.RegisterAddon(self, false, "", {"Gemini:GUI-1.0"})
--	Apollo.RegisterAddon(self)
--end

local defaults = {
	profile = {
		pos = {l=82,t=75,r=232,b=225},
		bShown = true,
		nOpacity = 0.65,
	}
}

--function addon:OnLoad()
	--
function addon:OnInitialize()
	--self.db = {}
	--self.db.profile = defaults.profile
	self.wBuffBar = Apollo.LoadForm("PoopEsperInnate.xml", "BuffBar", nil, self)
	self.wAnchor = Apollo.LoadForm("PoopEsperInnate.xml", "Anchor", nil, self)


	self.db = Apollo.GetPackage("Gemini:DB-1.0").tPackage:New(self, defaults, true)
	--self.db.profiles.Default = {
	--	pos = {l=82,t=75,r=232,b=225},
	--	bShown = true,
	--	nOpacity = 1,
	--}

	self.myOptionsTable = {
		type = "group",
		args = {
			header0 = {
				order = 1,
				name = "",
				type = "header",
			},
			bShown = {
				order = 2,
				name = "Lock/Unlock anchor",
				type = "toggle",
				width = "full",
				get = function(info) return self.db.profile[info[1]] end,
				set = function(info, v) self.db.profile[info[1]] = v; self.wAnchor:Show(v) self.wAnchor:SetOpacity(self.db.profile.nOpacity) end,
			},
			header1 = {
				order = 5,
				name = "",
				type = "header",
			},
			reset = {
				handler = self,
				order = 10,
				name = "Reset position",
				type = "execute",
				width = "full",
				func = "ResetPosition",
			},
			header2 = {
				order = 15,
				name = "",
				type = "header",
			},
			nOpacity = {
				order = 20,
				name = "Opacity",
				type = "range",
				min = 0,
				max = 1,
				step = 0.01,
				width = "full",
				get = function(info) return self.db.profile[info[1]] end,
				set = function(info, v) self.db.profile[info[1]] = v; self.wAnchor:SetOpacity(v) self.wBuffBar:SetOpacity(v) end,
			},
			header3 = {
				order = 25,
				name = "",
				type = "header",
			},
			tooltips = {
				handler = self,
				order = 30,
				name = "Get tooltips",
				type = "execute",
				width = "full",
				func = "GetTooltips",
			},
			header4 = {
				order = 35,
				name = "",
				type = "header",
			},
		}
	}
	GeminiConfig:RegisterOptionsTable("PoopEsperInnate", self.myOptionsTable)
	--Apollo.RegisterEventHandler("NextFrame", "OnUpdate", self)

	--Apollo.RegisterTimerHandler("PeI-FastTimer", "OnUpdate", self)
	--Apollo.CreateTimer("PeI-FastTimer", 0.03, true)
end

function addon:OnEnable()
	local uPlayer = GameLib.GetPlayerUnit() -- get the player, but only if we don't have it yet
	if not uPlayer then return end -- no player yet, stop!
	if uPlayer:GetClassId() ~= 3 then self.wBuffBar:Show(false) self.wAnchor:Show(false) return end -- if the player is not an Esper don't do anything
	Apollo.RegisterSlashCommand("pei", "OnSlashCommand", self)
	self.wAnchor:SetAnchorOffsets(self.db.profile.pos.l, self.db.profile.pos.t, self.db.profile.pos.r, self.db.profile.pos.b )
	self.wBuffBar:SetAnchorOffsets(self.db.profile.pos.l+nAnchorEdge,self.db.profile.pos.t+nAnchorEdge,self.db.profile.pos.r-nAnchorEdge,self.db.profile.pos.b-nAnchorEdge)
	self.wAnchor:AddEventHandler("WindowMove", "OnMoveOrResize", self)
	self.wAnchor:AddEventHandler("WindowSizeChanged", "OnMoveOrResize", self)

	self.wBuffBar:Show(true)
	self.wAnchor:Show(self.db.profile.bShown)
	self.wAnchor:SetOpacity(self.db.profile.nOpacity)
	self.wBuffBar:SetOpacity(self.db.profile.nOpacity)

	self.timer = self:ScheduleRepeatingTimer("OnUpdate", 0.1)
end

--function addon:CreateBuffWindowByIndex(i)
--	local tOptions = {
--		NoClip				= true,
--		HarmfulBuffs		= false,
--		BuffIndex			= i,
--	}
--	self.wBuffs = GeminiGUI:Create("BuffWindow", tOptions):GetInstance()
--	self.wBuffs:Show(true)
--	self.wBuffs:SetUnit(uPlayer)
--	local l,t,r,b = self.wAnchor:GetAnchorOffsets()
--	self.wBuffs:SetAnchorOffsets(l+nAnchorEdge,t+nAnchorEdge,r-nAnchorEdge,b-nAnchorEdge)
--end

function addon:OnUpdate()
	local uPlayer = GameLib.GetPlayerUnit() -- get the player, but only if we don't have it yet
	if not uPlayer then return end -- no player yet, stop!
	if uPlayer:GetClassId() ~= 3 then return end -- if the player is not an Esper don't do anything

	self.wBuffBar:SetUnit(uPlayer)
	local tBuffs = self.wBuffBar:GetChildren()
	local bFound = false
	if tBuffs then
		for _, wBuff in ipairs(tBuffs) do
			local sTooltip = wBuff:GetBuffTooltip()
			--if sTooltip:match("Psi Point every") then
			--"Granted 0 absorb, 1 Interrupt Armor, and generating 1 Psi Point every 0.0s."
			-- hopefully not likely to have a similarly structured tooltip for another buff
			--if sTooltip:match("%d+.*, %d+.*,.*%d.*\n.*%.") then -- to possibly work for more localization, assuming some comma usage and 3 numbers and newline
			-- This supposed to work for French clients too
			if sTooltip:match("%d+.*,.*%d.*%d.*\n.*%.") then  -- to possibly work for more localization, assuming some comma usage and 3 numbers and newline
			--D(v:GetSprite())
				wBuff:Show(true)
				bFound = true
				self.wBuffBar:ToFront()
			else
				wBuff:Show(false)
			end
		end
	end
	self.wBuffBar:Show(bFound)

	--local tBuffs = uPlayer:GetBuffs().arBeneficial
	--if not tBuffs or #tBuffs < 1 then return end -- no buffs
    --
	--for i, tBuffData in ipairs(tBuffs) do
	--	if tBuffData.splEffect:GetId() == nSpellId then -- we have that buff
	--		if nBuffIndex ~= i then -- only create/recreate the display if the index changed
	--			if self.wBuffs then self.wBuffs:Destroy() end -- destroy before creating
	--			self:CreateBuffWindowByIndex(i) -- create
	--			nBuffIndex = i -- save index
	--		end
	--		return
	--	end
	--end
	---- this runs if we didn't return before due to not having the buff
	--if self.wBuffs then
	--	self.wBuffs:Destroy()
	--	self.wBuffs = nil
	--	nBuffIndex = 0
	--end
end

function addon:ResetPosition()
	local l,t,r,b = 82,75,232,225
	self.db.profile.pos = {l=l,t=t,r=r,b=b}
	self.wAnchor:SetAnchorOffsets(l,t,r,b)
	self.wAnchor:Show(true)
	self.db.profile.bShown = true
	Print("PoopEsperInnate anchor position reseted. Use /pei to hide the anchor")
end

function addon:GetTooltips()
	local tBuffs = self.wBuffBar:GetChildren()
	if tBuffs then
		for k, v in ipairs(tBuffs) do
			Print(v:GetBuffTooltip())
		end
	end
end

function addon:OnSlashCommand(_, input)
	Apollo.GetPackage("Gemini:ConfigDialog-1.0").tPackage:Open("PoopEsperInnate")
	--if input:lower():find("reset") then
	--	self:ResetPosition()
	--elseif input:lower():find("tooltip") then
	--	self:GetTooltips()
	--elseif input:lower():find("tooltip") then
    --
	--else
	--	self.wAnchor:Show(not self.wAnchor:IsShown())
	--end
end

-- in case someone trys to do the config while using the innate too
function addon:OnMoveOrResize()
	--if not self.wBuffs then return end
	if not self.wBuffBar then return end
	local l,t,r,b = self.wAnchor:GetAnchorOffsets()
	self.db.profile.pos = {l=l,t=t,r=r,b=b}
	--self.wBuffs:SetAnchorOffsets(l+nAnchorEdge,t+nAnchorEdge,r-nAnchorEdge,b-nAnchorEdge)
	self.wBuffBar:SetAnchorOffsets(l+nAnchorEdge,t+nAnchorEdge,r-nAnchorEdge,b-nAnchorEdge)
end

--function addon:OnSave(eLevel)
--	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
--	--local tDB = {}
--	--local l,t,r,b = self.wAnchor:GetAnchorOffsets()
--	--tDB.pos = { l = l, t = t, r = r, b = b }
--	--tDB.show = self.wAnchor:IsShown()
--	--return tDB
--	return self.db.profile
--end

--function addon:OnRestore(eLevel, tData)
--	if eLevel == GameLib.CodeEnumAddonSaveLevel.Character then
--	--if tData.pos and self.wAnchor then
--	--	self.wAnchor:SetAnchorOffsets(tData.pos.l, tData.pos.t, tData.pos.r, tData.pos.b )
--	--	self.wBuffBar:SetAnchorOffsets(tData.pos.l+nAnchorEdge,tData.pos.t+nAnchorEdge,tData.pos.r-nAnchorEdge,tData.pos.b-nAnchorEdge)
--	--	self.wAnchor:Show(tData.show)
--	--end
--	self.db.profile = tData
--	end
--end

--local PoopEsperInnateInst = addon:new()
--PoopEsperInnateInst:Init()
